//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <complex>

#include <conio.h>   //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main (int argc, char* argv[])
{
  //       
  //  -  : 4.0
  //  -  : 3.0
  complex<double> c1(4.0,3.0);

  //       
  //  - : 5.0
  //  -  : 0.75
  complex<float> c2(polar(5.0,0.75));

  //        
  cout << "c1: " << c1 << endl;
  cout << "c2: " << c2 << endl;

  //      
  cout << "c1: " <<ToRus(": ") << abs(c1)
       << ToRus(" ( : ") << norm(c1) << ") "
       << ToRus("  : ") << arg(c1) << endl;
  cout << "c2: " <<ToRus(": ") << abs(c2)
       << ToRus(" ( : ") << norm(c2) << ") "
       << ToRus("  : ") << arg(c2) << endl;

  //    
  cout << "c1 " << ToRus(" : ") << conj(c1) << endl;
  cout << "c2 " << ToRus(" : ") << conj(c2) << endl;
  //   
  cout << "4.4 + c1 * 1.8: " << 4.4 + c1 * 1.8 << endl;

  //   c1  c2:
  //  - :  !
  cout << "c1 + c2:        "
       << c1 + complex<double>(c2.real(),c2.imag()) << endl;

  //   1    c1   
  cout << "c1 += sqrt(c1): " << (c1 += sqrt(c1)) << endl;


  getch();
  return 0;
}

//---------------------------------------------------------------------------